
/************************************************************************/
/*									*/
/*     : CONVERT.C						*/
/*       : תɫSPT16ɫBMP(Windows Paintbrush)16ɫPIC	*/
/*            (IBM Storyboard)16ɫCLP(Windows Clipboard)ļĸʽ*/
/*     : 							*/
/*   ޸ļ: ǿ							*/
/*   汾    : V1.00							*/
/*   ʱ    : 1993,4							*/
/*									*/
/************************************************************************/

#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <mem.h>
#include <string.h>
#include <alloc.h>
#include <dos.h>
#include <conio.h>
#include <dir.h>

typedef struct
{                                /*    ʹԶ̶                           */
  char huge *start,              /*    ָԶ̶ѵʼַ                 */
       huge *p;                  /*    ָԶ̶ѵĵǰַ                 */
} farmem;

long int compres(FILE *dest,FILE *fs); /*    ѹָļ                   */
void spttobmp(char *,char *);    /*    spt ļת bmp ļ              */
void bmptospt(char *,char *);    /*    bmp ļת spt ļ              */
void bmptopic(char *,char *);    /*    bmp ļת pic ļ              */
void pictobmp(char *,char *);    /*    pic ļת bmp ļ              */
void clptopic(char *,char *);	 /*    clp ļת pic ļ		    */
void expand(farmem *,FILE *);    /*    չ pic ļ                        */
void gotoxy(int x,int y);        /*    ѹ궨λ(x,y)                    */
void inputname(char *,char *,char *); /*     ļ                     */
int  load(farmem ,FILE *,long);  /*    ļװԶ̶                     */
void farread(farmem *,char far *,unsigned); /*     Զ̶Ѷ               */
void farwrite(farmem *,char *,unsigned); /*    Զ̶д                   */
void farseek(farmem *,long);     /*    λԶ̶ѵĳһλ               */
int  openfile(char *,char *,FILE **,FILE **); /*    ļ                */
void prcdisp(int);               /*    ʾٷ                           */

char bmpcolor[]={                /*    bmp ļɫת                   */
0xf,0x4,0xd,0xa,0x1,0x6,0x8,0x3,
0xb,0x7,0xe,0x9,0x2,0x05,0xc,0x0
};

char piccolor[16]={               /*     pic ļɫת                 */
0xf, 0x2, 0x3, 0xe, 0x8, 0xb, 0xa ,0x9,
0x6, 0xd, 0xc, 0x1, 0x7, 0x4, 0x5, 0x0
};

unsigned char spthead[64]={       /*     spt ļͷ                         */
0x53,0x75,0x70,0x65,0x72,0x2d,0x53,0x74,0x61,0x72,0x20,
0x46,0x69,0x6c,0x65,0x1a,0x00,0x01,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xc0,0xee,0xc3,0xf7,0x40,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

unsigned char bmphead[0x76]={     /*     16ɫ bmp ļͷ                    */
0x42,0x4d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x76,0x00,
0x00,0x00,0x28,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x01,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x80,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x80,0x00,0x80,0x00,
0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x80,0x00,0x00,0x80,0x80,
0x80,0x00,0x40,0x40,0x40,0x00,0x00,0x00,0xff,0x00,0x00,0xff,
0x00,0x00,0x00,0xff,0xff,0x00,0xff,0x00,0x00,0x00,0xff,0x00,
0xff,0x00,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x00
};

unsigned char pichead[0x800]={    /*     16ɫpic ļͷ                     */
0x0,0x84,0xc1,0x7,0x0,0x80,0x2,0xe0,0x1,0x4,0x0,0x2,0x0,0x3f,
0x0,0x38,0x7,0x2,0x3a,0x4,0x3c,0x1,0x39,0x6,0x3e,0x5,0x3d,0x3,
0x3b,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,
0xff,0xff,0xff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0xd0,0x11,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,
0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x55,
0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,
0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x55,0xaa,0x55,0xaa,0x55,0xaa,
0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0x55,0xaa,0x55,0xaa,0x55,0xaa,
0x55,0xaa,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,
0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,
0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x55,0xaa,0x55,0xaa,0x55,0xaa,
0x55,0xaa,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x55,0xaa,0x55,0xaa,0x55,0xaa,
0x55,0xaa,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,
0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x55,0xaa,0x55,0xaa,0x55,
0xaa,0x55,0xaa,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x55,0xaa,
0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,
0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,
0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0x0,0xff,0x0,0xff,0x0,0xff,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0x0,0xff,0x0,0xff,0x0,0xff,
0x99,0x99,0x99,0x99,0x99,0x99,0x99,0x99,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x22,0x11,0x88,0x44,0x22,0x11,0x88,0x44,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f,0x9f,0xcf,0xe7,0xf3,0xf9,
0xfc,0x7e,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xcc,0x99,0x33,0x66,0xcc,0x99,0x33,0x66,0xcc,0x99,0x33,0x66,
0xcc,0x99,0x33,0x66,0x33,0x66,0xcc,0x99,0x33,0x66,0xcc,0x99,0x33,0x66,0xcc,0x99,0x33,0x66,0xcc,0x99,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf,0x1e,0x3c,0x78,0xf0,0xe1,0xc3,0x87,
0xf,0x1e,0x3c,0x78,0xf0,0xe1,0xc3,0x87,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x33,0x0,0x33,0x0,0x33,0x0,0x33,0x0,
0xcc,0xff,0xcc,0xff,0xcc,0xff,0xcc,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x18,0xff,0x18,0x18,0x18,0xff,0x18,0x18,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x18,0xff,0x18,0x18,0x18,0xff,0x18,0x18,
0x55,0x2a,0x55,0xa2,0x55,0x2a,0x55,0xa2,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x55,0xab,0x55,0xba,0x55,0xab,0x55,0xba,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0x7e,0xff,0xe7,0xff,0x7e,0xff,0xe7,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x0,0x81,0x0,0x18,0x0,0x81,0x0,0x18,
0x33,0x33,0xcc,0xcc,0x33,0x33,0xcc,0xcc,0x33,0x33,0xcc,0xcc,0x33,0x33,0xcc,0xcc,
0x33,0x33,0xcc,0xcc,0x33,0x33,0xcc,0xcc,0xcc,0xcc,0x33,0x33,0xcc,0xcc,0x33,0x33,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0xf0,0xf0,0xf,0xf,0xf0,0xf0,0xf,0xf,0xf0,0xf0,0xf,0xf,0xf0,0xf0,0xf,0xf,
0xff,0x38,0x38,0xf8,0xc0,0xc0,0xff,0xff,0xff,0x38,0x38,0xf8,0xc0,0xc0,0xff,0xff,
0x0,0xc7,0xc7,0x7,0x3f,0x3f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0xe6,0x7c,0xde,0x8b,0xd1,0x7b,0x3e,0x67,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0xe6,0x7c,0xde,0x8b,0xd1,0x7b,0x3e,0x67,0x19,0x83,0x21,0x74,0x2e,0x84,0xc1,0x98,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x7e,0x7e,0x3c,0x3c,0x7e,0x7e,0x3c,0x3c,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe7,0xe7,0xff,0xff,0xe7,0xe7,0xff,0xff,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xe3,0x0,0x0,0xe3,0xe3,0xe3,0xe3,0xe3,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xc0,0xc0,0xce,0xce,0xce,0xc0,0xff,0xff,0xc0,0xc0,0xce,0xce,0xce,0xc0,0xff,
0x0,0x3f,0x3f,0x31,0x31,0x31,0x3f,0x0,0xff,0xc0,0xc0,0xce,0xce,0xce,0xc0,0xff,
0x0,0x18,0x18,0x7e,0x7e,0x18,0x18,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x18,0x18,0x7e,0x7e,0x18,0x18,0x0,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x81,0x0,0x0,0x18,0x18,0x0,0x0,0x81,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xbd,0x3c,0xc3,0xdb,0xdb,0xc3,0x3c,0xbd,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xef,0xc7,0x10,0xc7,0xef,0xef,0xef,0xef,
0xef,0xc7,0x10,0xc7,0xef,0xef,0xef,0xef,0xff,0xff,0xef,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x8a,0x15,0x2a,0x14,0x88,0x41,0xa2,0x45,
0x8a,0x15,0x2a,0x14,0x88,0x41,0xa2,0x45,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf8,0xff,0xc7,0xe7,0xf3,0xff,0x3f,0x3e,
0xf8,0xff,0xc7,0xe7,0xf3,0xff,0x3f,0x3e,0x7,0x0,0x38,0x18,0xc,0x0,0xc0,0xc1,
0x8f,0x27,0x72,0xf8,0x7c,0x39,0x93,0xc7,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x8f,0x27,0x72,0xf8,0x7c,0x39,0x93,0xc7,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x30,0x18,0x8c,0xc6,0x63,0x31,0x18,0xc,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x80,0xc0,0x60,0x30,0x18,0xc,0x30,0x18,0xc,0x6,0x3,0x1,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x18,0x3c,0x42,0x81,0x81,0x81,0x42,0x3c,0xe7,0xc3,0xbd,0x7e,0x7e,0x7e,0xbd,0xc3,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x7f,0x0,0xf7,0xf7,0xf7,0x0,0x7f,0x7f,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0xc7,0x8b,0x11,0xb8,0x7c,0x3a,0x11,0xa3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x38,0x74,0xee,0x47,0x83,0xc5,0xee,0x5c,
0x7f,0x0,0xf7,0xf7,0xf7,0x0,0x7f,0x7f,0x7f,0x0,0xf7,0xf7,0xf7,0x0,0x7f,0x7f,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0xff,0x8,0x8,0x8,0xff,0x80,0x80,
0x18,0x7e,0x42,0x99,0x99,0x42,0x7e,0x18,0xe7,0x81,0xbd,0x66,0x66,0xbd,0x81,0xe7,
0xe7,0x81,0xbd,0x66,0x66,0xbd,0x81,0xe7,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x7f,0xbf,0xdf,0xef,0xef,0xdf,0xbf,0x7f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
};

FILE *bmp,*spt,*pic,*clp;

unsigned char *oneline;
unsigned char colorpad[4];
unsigned char tempch1,tempch2;
unsigned char *bmponeline,*sptoneline;
unsigned char mask;
long int offset,width,height,compress,count,bmplinebyte,sptlinebyte,length;
unsigned int colornum,bytewidth;
unsigned int i,j,m,n;
unsigned int bytes,bkcolor,ftcolor;
char buffer[8],buf[4],res[4],temp,result;

int main()
{
  int i;
  struct ffblk list;
  void (* convert)(char *,char *);
  char dest[20],source[20];
  char prompt[4][37]={ "Input Super Star file name (*.spt): ",
                            /*   spt ļʾϢ                            */
                       "Input Paintbrush file name (*.bmp): ",
                            /*   bmp ļʾϢ                            */
                       "Input Storyboard file name (*.pic): ",
                            /*   pic ļʾϢ                            */
                       "Input Clipboard file name (*.clp): "
                            /*   clp ļʾϢ                            */
                         };
  char fix[4][5]={".SPT",   /*   spt ļȱʡ׺                            */
                  ".BMP",   /*   bmp ļȱʡ׺                            */
                  ".PIC",   /*   pic ļȱʡ׺                            */
                  ".CLP"};  /*   clp ļȱʡ׺                            */
  clrscr();
  gotoxy(1,5);
  printf("Option - 1: Change Super Star file to Paintbrush file.\n");
  gotoxy(1,6);
  printf("         2: Change Paintbrush file to Super Star file.\n");
  gotoxy(1,7);
  printf("         3: Change Paintbrush file to Storyboard file.\n");
  gotoxy(1,8);
  printf("         4: Change Storyboard file to Paintbrush file.\n");
  gotoxy(1,9);
  printf("         5: Change Clipboard file to Storyboard file.\n");
  gotoxy(1,10);
  printf("Your Selection[1-5]: ");
  while (1)
  {
    gotoxy(24,10);
    i=getche();
    if (i<0x36 && i>0x30)
      break;
  }
  printf("\n");
  switch (i)
  {
    case 0x31  : printf("\nbackcolor: ");
               scanf("%d",&bkcolor);
                             /*    תıɫ                          */
               if (bkcolor>15 ||bkcolor<0) bkcolor=15;
                             /*    Χ,дȱʡֵ15                 */
               tempch1=(unsigned char)bkcolor;
               printf("color: ");
               scanf("%d",&ftcolor);
                             /*    תǰɫ                          */
               if (ftcolor>15 ||ftcolor<0) ftcolor=0;
                             /*    Χ,дȱʡֵ0                  */
               tempch2=(unsigned char)ftcolor;
               colorpad[0]=(tempch1<<4)|tempch1;
                             /*    ǰ뱳ɫòɫֵ          */
               colorpad[1]=(tempch1<<4)|tempch2;
               colorpad[2]=(tempch2<<4)|tempch1;
               colorpad[3]=(tempch2<<4)|tempch2;
               inputname(prompt[0],fix[0],source);
                             /*    ļ                                */
               i=1;          /*    ȷĿļ׺ֵ                  */
               convert=spttobmp;
                             /*    ȷת                              */
               break;
    case 0x32  : inputname(prompt[1],fix[1],source);
                             /*    ļ                                */
               i=0;          /*    ȷĿļ׺ֵ                  */
               convert=bmptospt;
                              /*    ȷת                              */
               break;
    case 0x33  : inputname(prompt[1],fix[1],source);
                             /*    ļ                                */
               i=2;          /*    ȷĿļ׺ֵ                  */
               convert=bmptopic;
                              /*    ȷת                              */
               break;
    case 0x34  : inputname(prompt[2],fix[2],source);
               convert=pictobmp;
               i=1;
               break;
    case 0x35  : inputname(prompt[3],fix[3],source);
               convert=clptopic;
               i=2;
                          }
    if (findfirst(source,&list,0))
                             /*    ƥĵһĿ¼                    */
    {
      printf("file not found!");
      exit(1);
             }
    strcpy(dest,list.ff_name);
                             /*    תĿļļ                    */
    strcpy(strchr(dest,'.'),fix[i]);
    (* convert)(dest,list.ff_name);
                             /*    Ӧת                        */
    while (!findnext(&list))
                             /*    ƥһĿ¼                    */
    {
     strcpy(dest,list.ff_name);
                             /*    תĿļļ                    */
     strcpy(strchr(dest,'.'),fix[i]);
     (* convert)(dest,list.ff_name);
                             /*    Ӧת                        */
     }
  return(0);
}

/*****************************************************************************/
/*                                                                           */
/*  ڲ :                                                               */
/*        dest       char* Ŀ(BMP)ļļ                             */
/*        source     char* Դ(SPT)ļļ                               */
/*                                                                           */
/*  ˵     :  SPTļӦΪɫѹģʽתBMPļΪ16ɫѹ       */
/*              ģʽ                                                       */
/*                                                                           */
/*****************************************************************************/
void spttobmp(char *dest,char *source)
{
  if (openfile(dest,source,&bmp,&spt)) return;
                           /*    ԴĿļ                            */
  printf("\n%s=>%s     ",source,dest);
  prcdisp(-1);             /*    ٷʾ                              */
  fseek(spt,34,SEEK_SET);  /*     spt ļͼ                       */
  fread(&width,2,1,spt);
  fseek(spt,36,SEEK_SET);  /*     spt ļͼ߶                       */
  fread(&height,2,1,spt);
  sptlinebyte=(width+7)/8; /*    spt ļһռֽ                */
  bmplinebyte=(((width+1)/2+3)/4)*4;
                           /*    bmp ļһռֽ                */
  length=0x76+bmplinebyte*height;
                           /*    bmp ļ                                */
  memcpy(&bmphead[2],&length,4);
                           /*    bmp ļȸƵ bmp ļͷ               */
  memcpy(&bmphead[18],&width,2);
                           /*    ͼȸƵ bmp ļͷ                   */
  memcpy(&bmphead[22],&height,2);
                           /*    ͼ߶ȸƵ bmp ļͷ                   */
  fwrite(bmphead,0x76,1,bmp);
                           /*    д bmp ļͷ                               */

  bmponeline=malloc(bmplinebyte);
                           /*    Ϊ bmp ļһطڴռ           */
  sptoneline=malloc(sptlinebyte);
                           /*    Ϊ spt ļһطڴռ           */
  for(i=0;i<height;i++)
  {
    prcdisp((float)i*100/height);
                           /*    ʾٷʾ                              */
    offset=64+sptlinebyte*(height-i-1);
                           /*    height-isptļеλ           */
    fseek(spt,offset,SEEK_SET);
    fread(sptoneline,sptlinebyte,1,spt);
                           /*    height-i                        */
    for(j=0;j<sptlinebyte;j++)
    {
      for(m=0,mask=0xc0;m<4;m++)
      {
         n=(sptoneline[j]&mask)>>(6-m*2);
                           /*    ȡ2bit(2)                       */
         bmponeline[j*4+m]=colorpad[n];
                           /*    ת2صĲɫֵ                       */
         mask>>=2;
                   }}
    fwrite(bmponeline,bmplinebyte,1,bmp);
                           /*    תõһдĿļ              */
                                     }
  prcdisp(100);
  free(sptoneline);        /*    ͷڴ                                    */
  free(bmponeline);
  fclose(bmp);
  fclose(spt);
              }


/*****************************************************************************/
/*                                                                           */
/*  ڲ :                                                               */
/*        dest       char* Ŀ(BMP)ļļ                             */
/*        source     char* Դ(SPT)ļļ                               */
/*                                                                           */
/*  ˵     :  BMPļӦΪɫѹģʽתSPTļΪɫѹ       */
/*              ģʽ                                                       */
/*                                                                           */
/*****************************************************************************/
void bmptospt(char *dest,char *source)
{
  if (openfile(dest,source,&spt,&bmp)) return;
  fseek(bmp,18,SEEK_SET);
  fread(&width,2,1,bmp);        /*     bmp ļͼ                  */
  fseek(bmp,22,SEEK_SET);
  fread(&height,2,1,bmp);       /*     bmp ļͼ߶                  */
  fseek(bmp,2,SEEK_CUR);
  fread(&colornum,sizeof(int),1,bmp);
                                /*    ɫλ                           */
  if (colornum!=1)
  {                             /*    ǵɫλͼʽ                     */
    printf("Source file is not in 2-color format!\n");
    fclose(bmp);
    fclose(spt);
    remove(dest);
    return;
            }
  fread(&compress,sizeof(long int),1,bmp);
  if (compress)
  {                             /*  Ϊѹʽ                             */
    printf("Source file is in compress format!\n");
    fclose(bmp);
    fclose(spt);
    remove(dest);
    return;
            }
  printf("%s=>%s    ",source,dest);
  prcdisp(-1);                  /*    ٷʾ                         */
  bmplinebyte=sptlinebyte=((width+31)/32)*4;
                                /*    sptbmpļһռֽ       */
  memcpy(&spthead[34],&width,2);/*    ͼȸƵ bmp ļͷ              */
  memcpy(&spthead[36],&height,2);
                                /*    ͼȸƵ bmp ļͷ              */
  fwrite(spthead,64,1,spt);     /*    д bmp ļͷ                          */
  bmponeline=sptoneline=malloc(bmplinebyte);
                                /*    Ϊ bmp ļһطڴռ      */
  for(i=0;i<height;i++)
  {
    prcdisp((float)i*100/(height));
                                /*    ʾٷʾ                         */
    offset=bmplinebyte*(i+1);   /*    ibmpļеƫ       */
    fseek(bmp,-offset,SEEK_END);
    fread(bmponeline,bmplinebyte,1,bmp);
                                /*    i                          */
    fwrite(sptoneline,sptlinebyte,1,spt);
                                /*    дsptļ                            */
                                      }
  prcdisp(100);                 /*    ʾٷʾ                         */
  free(bmponeline);             /*    ͷڴ                               */
  fclose(bmp);
  fclose(spt);
             }


/*****************************************************************************/
/*                                                                           */
/*  ڲ :                                                               */
/*        dest       char* Ŀ(PIC)ļļ                             */
/*        source     char* Դ(BMP)ļļ                               */
/*                                                                           */
/*  ˵     :  BMPļӦΪ16ɫѹģʽתPICļΪ16ɫѹ         */
/*              ģʽ                                                       */
/*                                                                           */
/*****************************************************************************/
void bmptopic(char * dest,char *source)
{
  /*  picʽͼȰĻϵһ1-8صĲɫֵת,Ȼ        */
  /*  (4bit*8)λת4ֽ,1ֽڴ8صĵ0λɫֵ,2  */
  /*  ڴ8صĵ1λɫֵһ8תú,תڶ */
  /*  е1-8,ȥ1-8ȫתú,ת9-16   */
  /*  ءֱĻص㶼תáһͼתΪĸݿ飺   */
  /*  һݿصĵһλɫֵ,ڶݿصĵڶ  */
  /*  λɫֵ, ȥٶĸݿ鰴·ѹݿ   */
  /*  n(n<127)ֽ, nλΪ1, Ȼn͸ֽ;   */
  /*  nȵֽ, nͲȵnֽڡ                    */
  FILE * tempfile[4];          /*     ĸݿʱļ               */
  farmem hp;                   /*     Զ̶϶һݿ                 */
  char tempfilename[4][13];
  printf("%s=>%s    ",source,dest);
  if (openfile(dest,source,&pic,&bmp)) return;
  fseek(bmp,2,SEEK_SET);
  fread(&length,sizeof(long),1,bmp);
                               /*     bmpԴļĳ                    */
  fseek(bmp,0x0a,SEEK_SET);
  fread(&offset,sizeof(long int),1,bmp);
                               /*     λͼbmpļеƫ        */
  fseek(bmp,4,SEEK_CUR);
  fread(&width,sizeof(long int),1,bmp);
                               /*     ͼ                           */
  fread(&height,sizeof(long int),1,bmp);
                               /*     ͼ߶                           */
 fseek(bmp,2,SEEK_CUR);
  fread(&colornum,sizeof(int),1,bmp);
                               /*     ɫλ                           */
  if (colornum!=4)
  {
                               /*     16ɫλͼʽ                       */
    printf("Source file is not in 16-color format!\n");
    fclose(bmp);
    fclose(pic);
    remove(dest);
    return;
            }
  fread(&compress,sizeof(long int),1,bmp);
                               /*     ѹ־                           */
  if (compress)
  {
                               /*     Ϊѹʽ                           */
    printf("Source file is in compress format!\n");
    fclose(bmp);
    fclose(pic);
    remove(dest);
    return;
            }
  if (allocate(&hp,length)) return;
   for(i=0;i<4;i++)
    if ((tempfile[i]=fopen(tmpnam(tempfilename[i]),"wb"))==NULL)
      {
        printf("Can't create temperory file on disk!\n");
        fclose(bmp);
        exit(1);
               }
  bytewidth=((width+1)/2+3)/4*4;
                          /*   һbmpļռֽ             */
  prcdisp(-1);            /*   ٷʾ                                */
  fseek(bmp,0x76,SEEK_SET);
  load(hp,bmp,length);    /*   Զ̶Ч, bmpԴļװԶ̶   */
  for(i=0;i<bytewidth/4;i++)
  {
    prcdisp((float)i*60/(bytewidth/4));
                          /*   ʾٷʾ                                */
    farseek(&hp,(height-1)*bytewidth+i*sizeof(long int));
                          /*   λͼһеĵiص                 */
    for(j=0;j<height;j++)
    {
      farread(&hp,(char far *)(&buf),sizeof(long));
                          /*   ͼjеĵiص                    */
      farseek(&hp,(height-2-j)*bytewidth+i*sizeof(long int));
                          /*   λͼj+1еĵiص                */
      for(m=0;m<4;m++)
      {
                          /*   صĲɫֵתΪpicʽĲɫֵ,      */
                          /*   buffer                                  */
        temp=(buf[m]&0xf0)>>4;
        buffer[m*2]=piccolor[temp];
        temp=buf[m]&0x0f;
        buffer[m*2+1]=piccolor[temp];
                               }
       for(m=0;m<4;m++)
       {
         for(n=0,result=0;n<8;n++)
         {
                          /*   ȡbufferиԪصĵnλ, һֽ */
           result=(result<<1)|(buffer[n]&0x01);
           buffer[n]=buffer[n]>>1;
                                  }
         fwrite(&result,sizeof(char),1,tempfile[m]);
                          /*    Ѹֽдʱļ                       */
                       }}}
  farfree(hp.start);      /*    ͷԶ̶                                   */
  memcpy(&pichead[0x5],&width,sizeof(int));
                          /*    ͼȿpicļͷ                  */
  memcpy(&pichead[0x7],&height,sizeof(int));
                          /*    ͼ߶ȿpicļͷ                  */
  fwrite(pichead,0x800,1,pic);
                          /*    picĿļдļͷ                      */
  for(i=0,count=0x800;i<4;i++)
  {
    prcdisp(60+i*10);     /*    ʾٷʾ                               */
    fclose(tempfile[i]);
    tempfile[i]=fopen(tempfilename[i],"rb");
                          /*    ´ʱļ                             */
    count+=compres(pic,tempfile[i]);
                          /*    ѹʱļ                                 */
    fclose(tempfile[i]);
    remove(tempfilename[i]);
                          /*    ʱļ                                 */
                                        }
  fseek(pic,0x7c,SEEK_SET);
  fwrite(&count,sizeof(long int),1,pic);
                          /*    дpicļ                              */
  prcdisp(100);
  fclose(bmp);
  fclose(pic);
  return;
                  }
long int compres(FILE *dest,FILE * fs)
{
  long int cbbytes=0;     /*     дĿļֽڼ                      */
  int current,            /*     ָ򻺳β                      */
            i;
  unsigned char  ch,      /*     ֽ                                    */
                cbequal,  /*     ֽͬڵļ                              */
                cbnoequal,/*     ֽͬڵļ                              */
                buffer[128];
                          /*     뻺                                  */
start :
  current=0;
  cbequal=cbnoequal=1;
  fread(&buffer[current++],sizeof(char),1,fs);
                          /*     ʱļжһֽ                      */
  while (1)
  {
    fread(&ch,sizeof(char),1,fs);
                          /*     ʱļжһֽ                      */
    if (feof(fs)) break;  /*     ʱļ, ˳ѭ                      */
    if (ch==buffer[current-1])
                          /*     ֽڵڱȽֽ                      */
    {
       cbequal++;         /*     ֽڼһ                            */
       if (cbnoequal==1)  /*     Ƿвȵֽ                    */
       {
         if (cbequal>=125)/*     ֽڵļǷ125                   */
         {
           cbequal=cbequal|0x80;
                          /*     ֽڼȱ־                          */
           fwrite(&cbequal,sizeof(char),1,dest);
                          /*     Ŀļдֽڼ                      */
           fwrite(&buffer,sizeof(char),1,dest);
                          /*     дֽ                                */
           cbbytes+=2;    /*     ֽڳȼ                            */
           goto start;
                       }}
         else
         {
           cbnoequal--;   /*     ֽ,  ˲ֽڼҪһ     */
           fwrite(&cbnoequal,sizeof(char),1,dest);
                          /*     Ŀļдֽڼ                      */
           fwrite(&buffer,cbnoequal,1,dest);
                          /*     дֽ                                */
           cbbytes+=cbnoequal+1;
                          /*     ֽڳȼ                            */
           buffer[0]=ch ; /*     ȵֽƵ                      */
           current=1;     /*     βָ                            */
           cbnoequal=1;   /*     ֽڼ                                */
           cbequal=2;
                             } }
       else
       {
         if (cbequal==1)  /*     Ƿȵֽ                    */
         {
           buffer[current++]=ch;
           cbnoequal++;   /*     ֽڼһ                            */
           if (cbnoequal>=125)
                          /*     ֽڼǷ14                      */
           {
             fwrite(&cbnoequal,sizeof(char),1,dest);
                          /*     дֽڼ                                */
             fwrite(&buffer,cbnoequal,1,dest);
                          /*     дֽ                                */
             cbbytes+=1+cbnoequal;
                          /*     ֽڳȼ                            */
             goto start;
                           }}
          else
          {
            cbequal=cbequal|0x80;
                          /*     ֽڼȱ־                          */
            fwrite(&cbequal,sizeof(char),1,dest);
                          /*     Ŀļдֽڼ                      */
            fwrite(&buffer,sizeof(char),1,dest);
                          /*     дֽ                                */
            cbbytes+=2;   /*     ֽڳȼ                            */
            cbequal=1;    /*     ֽڼ                                */
            buffer[0]=ch; /*     ѲȵֽƵ                  */
            current=1;    /*     βָ                            */
                       }}}
  if (cbequal!=1)         /*     Ƿȵֽ                    */
  {
    cbequal=cbequal|0x80; /*     ֽڼȱ־                          */
    fwrite(&cbequal,sizeof(char),1,dest);
                          /*     дֽڼ                                */
    fwrite(&buffer,sizeof(char),1,dest);
                          /*     дֽ                                */
    cbbytes+=2;           /*     ֽڳȼ                            */
                         }
  else
  {
    fwrite(&cbnoequal,sizeof(char),1,dest);
                          /*     дֽڼ                                */
    fwrite(&buffer,cbnoequal,1,dest);
                          /*     дֽ                                */
    cbbytes+=1+cbnoequal; /*     ֽڳȼ                            */
                          }
  return(cbbytes);        /*     ֽڳȼ                            */
                      }
void pictobmp(char *dest,char *source)
{
  char far *plane[4],far *pointer[4];
  farmem hp;
  printf("%s=>%s    ",source,dest);
  if (openfile(dest,source,&bmp,&pic)) return;
  fseek(pic,5,SEEK_SET);
  fread(&width,sizeof(int),1,pic);
                          /*     picԴļĳ                         */
  fread(&height,sizeof(int),1,pic);
                          /*     λͼbmpļеƫ             */
  bmplinebyte=((width+1)/2+3)/4*4;
  length=0x76+bmplinebyte*height;
                          /*      bmp ļ                               */
  memcpy(&bmphead[2],&length,4);
                          /*      bmp ļȸƵ bmp ļͷ              */
  memcpy(&bmphead[18],&width,2);
                          /*      ͼȸƵ bmp ļͷ                  */
  memcpy(&bmphead[22],&height,2);
                          /*      ͼ߶ȸƵ bmp ļͷ                  */
  fwrite(bmphead,0x76,1,bmp);
                          /*      д bmp ļͷ                              */
  if (allocate(&hp,length))
  {
    fclose(bmp);
    fclose(pic);
    remove(dest);
    return;
            }

  fseek(pic,0x800,SEEK_SET);
  prcdisp(-1);            /*      ʾٷʾ                             */
  prcdisp(0);
  expand(&hp,pic);        /*      ѹPICļָ                        */
  prcdisp(15);
  for(i=0;i<4;i++)
                          /*      planeԪָɫλݵʼ  */
    plane[i]=(width*height+7)/8*i+hp.start;
  bytewidth=(width+7)/8;  /*      һݵĳ                         */
  for(i=0;i<height;i++)
  {
    prcdisp(85*i/height+15);
    for(j=0;j<4;j++)
                          /*     pointerԪָɫλݵĵ   */
                          /*     iдΪBMPļͼһпʼ    */
                          /*                                             */
      pointer[j]=plane[j]+height-i-1;
    for(j=0;j<bytewidth;j++)
    {

      for(m=0;m<4;m++)
      {
        buf[m]=*pointer[m];
                          /*     ȡͼ                                */
        pointer[m]+=height;
                          /*     ָָһ                          */
                           }
      for(m=0;m<4;m++)
      {
        tempch1=tempch2=0;
        for(n=0;n<4;n++)
                          /*     ȡֽݵĳһλһֽ(λ   */
                          /*     Ч)Ĳɫֵ                                 */
        {
          tempch1=tempch1<<1;
          tempch1=tempch1|((buf[n]&0x80)?1:0);
          buf[n]=buf[n]<<1;
                          }
        tempch1=bmpcolor[tempch1];
                          /*     вɫת                                */
        for(n=0;n<4;n++)
                          /*     ȡֽݵĳһλһֽ(λ   */
                          /*     Ч)Ĳɫֵ                                 */
        {
          tempch2=tempch2<<1;
          tempch2=tempch2|((buf[n]&0x80)?1:0);
          buf[n]=buf[n]<<1;
                          }
        tempch2=bmpcolor[tempch2];
                          /*     вɫת                                */
        result=(tempch1<<4)|tempch2;
                          /*      ֽݺϲһֽ               */
        fwrite(&result,sizeof(char),1,bmp);
                          /*      дBMPļ                                */
                                             }}
    for(j=0;j<(4-((width+1)/2)%4)%4;j++)
                          /*      BMPļҪ, н,     */
                          /*      ʹһݵֽΪ4ı              */
       fwrite(0,sizeof(char),1,bmp);
                                     }
  prcdisp(100);
  farfree(hp.start);      /*      ͷԶ̶                                 */
  fclose(bmp);
  fclose(pic);
               }
void expand(farmem *hp,FILE *pic)
{
  unsigned char bcount;
  char buffer[128];
  while (1)
  {
    fread(&bcount,1,1,pic);/*     ֽڼ                               */
    if (feof(pic)) break;
    if (bcount>0x80)       /*     ֽڼǷ80H                        */
    {
      bcount=bcount&0x7f;  /*     ʵֽڳ                           */
      fread(&result,1,1,pic);
                           /*                                    */
      for(i=0;i<bcount;i++)/*     չʵʳ                             */
      {
         *hp->p=result;
         hp->p++;
                }}
    else
    {
      fread(buffer,bcount,1,pic);
                           /*                                    */
      farwrite(hp,buffer,bcount);
                                }}
  hp->p=hp->start;
                   }

void clptopic(char *dest,char *source)
{
  /*  WINDOWSеCLPļ(640*480*16ʽ)ֱӰĸɫƽ     */
  /*  CLPļ, ǰټһļͷ                                    */

  FILE *tempfile[4];
  char tempfilename[4][13];
  farmem hp;
  printf("%s => %s : ",source,dest);
  if (openfile(dest,source,&pic,&clp)) return;
  fseek(clp,6,SEEK_SET);
  fread(&length,sizeof(long),1,clp);
                          /*      bmpԴļĳ                        */
  fseek(clp,0xa,SEEK_SET);
  fread(&offset,sizeof(long),1,clp);
                          /*      λͼclpļеƫ            */
  fseek(clp,offset+2,SEEK_SET);
  fread(&width,sizeof(int),1,clp);
                          /*      ͼ                               */
  fread(&height,sizeof(int),1,clp);
                          /*      ͼ                               */
  fread(&bytewidth,sizeof(int),1,clp);
                          /*      һͼֽ                       */
  if (width/bytewidth!=8) /*      ͼɫλ                           */
  {
    fclose(pic);
    fclose(clp);
    remove(dest);
    return;
         }
  if (allocate(&hp,length)) return;
                          /*      Զ̶                                 */
  prcdisp(-1);
  prcdisp(0);
  fseek(clp,6,SEEK_CUR);
  load(hp,clp,length);    /*       λͼϢڴ                        */
  for(i=0;i<4;i++)
    if ((tempfile[i]=fopen(tmpnam(tempfilename[i]),"wb"))==NULL)
      {                   /*       ΪPICļ׼ʱļ                     */
        printf("Can't create temperory file on disk!\n");
        fclose(clp);
        fclose(pic);
        remove(dest);
        exit(1);
               }
  for(m=0;m<bytewidth;m++)
  {
    prcdisp(60*m/bytewidth);
    for(n=0;n<height;n++)
    {
      for(i=0;i<4;i++)
      {
        farseek(&hp,i*38400L+n*bytewidth+m);
        farread(&hp,&buf[i],sizeof(char));
                           /*      iɫƽĵnеĵmֽ   */
        buffer[i]=~buf[i]; /*      Ѹֽڸλȡ                          */
                       }
    res[0]=buffer[3]&(buffer[2]^buf[0]) |  buf[3]&(buf[2]^buf[0]);
    res[1]=buffer[3]&buffer[2] | buffer[3]&(buf[1]^buf[0])
            | buf[3]&buffer[1]&buffer[0];
    res[2]=buffer[2]&buffer[0]&buffer[1] | buffer[3]&buffer[2]&buf[1]&buf[0] |
             buf[3]&buffer[0] | buf[3]&buffer[1];
    res[3]=buffer[3]&(buffer[1]^buf[0]) | buf[3]&buffer[2]&(buf[1]^buf[0])|
            buffer[3]&buf[2];
                           /*      PICļĲɫ                   */
    for(i=0;i<4;i++)
      fwrite(&res[i],sizeof(char),1,tempfile[i]);
                           /*      дӦʱļ                        */
                                       }}
  farfree(hp.start);       /*      ͷԶ̶                                */
  memcpy(&pichead[0x5],&width,sizeof(int));
                           /*      ͼȿpicļͷ               */
  memcpy(&pichead[0x7],&height,sizeof(int));
                           /*      ͼ߶ȿpicļͷ               */
  fwrite(pichead,0x800,1,pic);
                           /*      picĿļдļͷ                   */
  for(i=0,count=0x800;i<4;i++)
  {
    prcdisp(60+i*10);      /*      ʾٷʾ                            */
    fclose(tempfile[i]);
    tempfile[i]=fopen(tempfilename[i],"rb");
                           /*      ´ʱļ                          */
    count+=compres(pic,tempfile[i]);
                           /*      ѹʱļ                              */
    fclose(tempfile[i]);
    remove(tempfilename[i]);
                           /*      ʱļ                              */
                                        }
  fseek(pic,0x7c,SEEK_SET);
  fwrite(&count,sizeof(long int),1,pic);
                           /*      дpicļ                           */
  prcdisp(100);
  fclose(clp);
  fclose(pic);
  return;
}



void gotoxy(int x,int y)
{
  union REGS in;
  in.h.ah=0x02;
  in.h.dh=y;
  in.h.dl=x;
  in.h.bh=0;
  int86(0x10,&in,&in);
  return;
}

void inputname(char * prompt,char * fix,char *name)
{
  printf(prompt);
  scanf("%s",name);
  if (strchr(name,'.')==NULL)
    strcat(name,fix);
}

void prcdisp(int percent)
{
  if (percent==100)
  {
    printf("\b\b100%   Done!\n");
    return;
  }
  if (percent==-1)
  {
    printf("  %\b");
    return;
  }
  printf("\b\b%2d",percent);
}

int allocate(farmem *hp,long lsize)
{
  if ((hp->p=hp->start=farmalloc(lsize))==NULL)
  {
    printf("File too big to load!\n");
    return(1);
  }
  return(0);
}

int load(farmem buffer,FILE *source,long size)
{
  char far *temp;
  unsigned i=1;
  if ((temp=malloc(4096))==NULL)
  {
    printf("Near heap full!\n");
    return(1);
  }
  for(;i;)
  {
    i=fread((void *)temp,1,4096,source);
    movedata(FP_SEG(temp),FP_OFF(temp),FP_SEG(buffer.p),
              FP_OFF(buffer.p),i);
    buffer.p+=i;
  }
  free(temp);
  return(0);
}

void farread(farmem *buffrom,char far * bufto,unsigned size)
{
  movedata(FP_SEG(buffrom->p),FP_OFF(buffrom->p),FP_SEG(bufto),
           FP_OFF(bufto),size);
  buffrom->p+=size;
  return;
}

void farwrite(farmem *bufto,char *buffrom,unsigned size)
{
  movedata(FP_SEG(buffrom),FP_OFF(buffrom),
           FP_SEG(bufto->p),FP_OFF(bufto->p),size);
  bufto->p+=size;
}

void farseek(farmem *hp,long location)
{
  hp->p=hp->start+location;
}

int openfile(char *dest,char *source,FILE **fdest,FILE **fsource)
{
  if ((*fsource=fopen(source,"rb"))==NULL)
  {
                                /*    򿪱תԴļ                     */
    printf("%s can't open!\n",source);
    return(1);
  }
  if ((*fdest=fopen(dest,"wb"))==NULL)
  {
                                 /*    תĿļ                  */
    printf("%s can't create!\n",dest);
    fclose(*fsource);
    return(1);
  }
  return(0);
}
